<?php
/*
 * Reads a simple BackendReader map file, and let the user
 * exclude a certaion feature for a particular product name
 */
class BackendReader {

	/**
	 * Comments starts with #
	 *
	 * Key word is: "Listen 127.0.0.1: " connected with the combined name e.g. "Listen 127.0.0.1:8880"
	 * Every line after this keyword, contains of a feature name that will excluded
	 * when showed in the WebGUI.
	 *
	 * Product names can use wildcars '?' to match any character or
	 * '*' to match any substring (0 or more characters).
	 *
	 */


	private $file;
	private $port;


	public function BackendReader($filename = null) {

		if (is_null($filename)) {
			throw new Exception("We need an input file..");
		}
		$this->file = $filename;
		$this->load();
	}

	private function load() {
//	if (!file_exists($this->file)) return;
//
//		// Parse the mapping file, to an easier format for looking up data..
//		$parser = new Parser(file_get_contents($this->file),
//		ParserSettings::create(ParserSettings::COMMENT_CHAR, '#')
//		->set(ParserSettings::SKIP_COMMENTS, true)
//		->set(ParserSettings::SKIP_BLANK_LINES, true)
//		);
//
//		// For each line we have...
//		while ($parser->hasMore()) {
//
//			// Get next line
//			$line = $parser->next();
//
//			// Check if got the keyword
//			if (strtolower(substr(trim($line->toString()), 0, 17)) == 'Listen 127.0.0.1:') {
//				$map = $line->next(ParserSettings::create(ParserSettings::SPLIT, ParserSettings::SPLIT_TYPE_SEMI_COLON));
//				$this->port = trim($map->get(1)->toString());
//				break;
//			}
//		}
		$file = fopen($this->file,"r");
		while(!feof($file)){
			$str = fgets($file);
			//echo strpos($str,"Listen 127.0.0.1:") . "strpos" . $str;
			if (strpos($str,"127.0.0.1:") != ""){
				$this->port = substr(trim($str), 17);
				break;
			}
		}
	}

	public function getPort() {
		//return substr($this->line, 17);
		return $this->port;
	}

}

new BackendReader("/var/opt/openit/etc/httpd/httpd.conf");
?>