<?php
/*
 * FeedWriter
 * 
 * This class will create/update the RSS feeds.
 * 
 */

class FeedWriter{
	
	//private $file;
	
	public function init() {	
		// Load the initiation file
		//echo "iniiiiiiiit";
		require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");
		//echo "required";
		if(!isset($_SESSION["USER"])){
			header('Location: /login.php');
			//echo "oy!!!";
		}
		//echo "calling write";
		FeedWriter::write();
		//echo "called";
	}
	
	public function write(){
		//echo "indeeex";
		RealTime::clearSelections();
		//echo "called realtime";
		$realtime = RealTime::getInstance(true);
		//echo "assigned realtime";
		//print_r($realtime);		
		$list = $realtime->getProducts(true);
		//echo "listed";

		//echo "wriiiiiite";
		$prefix = "http";
		if(isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on"){
			$prefix = "https";
		}
		//echo "httset";
		
		//product status feed
		$pstatfeed='<?xml version="1.0"?>
					<rss version="2.0">
					<channel>
					<title>Open iT - Status Monitor</title>
					<link>'. $prefix .'://'.$_SERVER['HTTP_HOST'] .'/module/product_status</link>
					<description></description>';
		foreach ($list as $product) {
			if ($product->getMinutesSinceUpdate() > 360) {
				$pstatfeed=$pstatfeed.'
					<item>
						<pubDate>'. date('r') .'</pubDate>
						<title>FATAL: '.$product->name .'</title>
						<description>'. $product->name .' has not been reporting the last '. $product->getLastSeenFormat() .'</description>
						<link>'. $prefix .'://'. $_SERVER['HTTP_HOST'] .'/module/product_status</link>
					</item>';
			}else if ($product->getMinutesSinceUpdate() > 60) {
				$pstatfeed=$pstatfeed.'
					<item>
						<pubDate>'. date('r') .'</pubDate>
						<title>CRITICAL: '.$product->name .'</title>
						<description>'. $product->name .' has not been reporting the last '. $product->getLastSeenFormat() .'</description>
						<link>'. $prefix .'://'. $_SERVER['HTTP_HOST'] .'/module/product_status</link>
					</item>';
			}else if ($product->getMinutesSinceUpdate() > 15) {
				$pstatfeed=$pstatfeed.'
					<item>
						<pubDate>'. date('r') .'</pubDate>
						<title>WARNING: '.$product->name .'</title>
						<description>'. $product->name .' has not been reporting the last '. $product->getLastSeenFormat() .'</description>
						<link>'. $prefix .'://'. $_SERVER['HTTP_HOST'] .'/module/product_status</link>
					</item>';
			}
 		}
 		
		$pstatfeed=$pstatfeed.'</channel></rss>';
		
		//counter for feature expiry status 
		$warning = 0;
		$critical = 0;
		$fatal = 0;
		foreach ($list as $product) { 
			$featureList = $product->getFeatures();
		
			foreach ($featureList as $feature) {
				//echo $feature->name . "-". $feature->getExpiry() . "<br>";
				$expiry = $feature->getExpiry();
				
				if ($expiry <= 0 || $expiry == "N/A"){
					$fatal++;
				}else if ($expiry >= 0 && $expiry < 168){
					$critical++;
				}else if ($expiry >= 168 && $expiry < 504){
					$warning++;
				}
			}
		}
		
		
		//feature status feed
		$fstatfeed='<?xml version="1.0"?>
					<rss version="2.0">
					<channel>
					<title>Open iT - Feature Status Monitor</title>
					<link>'. $prefix .'://'.$_SERVER['HTTP_HOST'] .'/module/feature_status</link>
					<description></description>
					<item>
						
						<pubDate>'. date('r') .'</pubDate>
						<title>WARNING: Features expiring in 3 weeks: '.$warning.'</title>
 						<description>Number of features that will expire within 3 weeks</description>
						<link>'. $prefix .'://'. $_SERVER['HTTP_HOST'] .'/module/feature_status</link>
					</item>
					<item>
						
						<pubDate>'. date('r') .'</pubDate>
						<title>CRITICAL: Features expiring in 1 week: '.$critical.'</title>
 						<description>Number of features that will expire within 1 week</description>
						<link>'. $prefix .'://'. $_SERVER['HTTP_HOST'] .'/module/feature_status</link>
					</item>
					<item>
						
						<pubDate>'. date('r') .'</pubDate>
						<title>FATAL: Features that are already expired: '.$fatal.'</title>
 						<description>Number of features that are already expired</description>
						<link>'. $prefix .'://'. $_SERVER['HTTP_HOST'] .'/module/feature_status</link>
					</item>
					</channel>        
					</rss>';
		
		/*
		//feature utilization percentage
		$futilzfeed='<?xml version="1.0"?>
					<rss version="2.0">
					<channel>
					<title>Open iT - Feature Utilization</title>
					<link>'. $prefix .'://'.$_SERVER['HTTP_HOST'] .'/module/product_status</link>
					<description></description>';
		$feat=$realtime->getFeatures(true);
		foreach($feat as $feature){
			
			echo $feature->name . " - ";
			echo $feature->getRealTimeLicenseUsage()." - ";
			echo $feature->getRealTimeTotaltLicenses().": ";
			echo ($feature->getRealTimeLicenseUsage()/$feature->getRealTimeTotaltLicenses())*100 . "<br>";
			
		}
		*/
		
		if (isset($_SESSION["USER"])){
			//write product status feed
			$fh=fopen('productstatfeed.xml','w');
			fwrite($fh,$pstatfeed);
			fclose($fh);
			//write feature status feed
			$fh=fopen('featurestatfeed.xml','w');
			fwrite($fh,$fstatfeed);
			fclose($fh);
		}
		
	}
}