<?php
header('Content-Type: application/xml');
?><?= '<?xml version="1.0"?>' ?>
<?php 
$prefix = "http";
if(isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on"){
	$prefix = "https";
}

$warning = 0;
$critical = 0;
$fatal = 0;
foreach ($list as $product) { 
	$featureList = $product->getFeatures();
	
	foreach ($featureList as $feature) {
		$expiry = $feature->getExpiry();
		if ($expiry >= 504 && $expiry < 672){
			$warning++;
		}else if ($expiry >= 168 && $expiry < 504){
			$critical++;
		}else{
			$fatal++;
		}
	}
}
?>	
<rss version="2.0">

	<channel>
		<title>Open iT - Feature Status Monitor</title>
		<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		<description></description>
	      
		<item>
			<guid isPermaLink="false"><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/FeatureStatusMonitor/<?= $feature->name ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>WARNING: Features expiring in 3 weeks: <?=$warning?></title>
 			<description>Number of features that will expire within 3 weeks</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
		<item>
			<guid isPermaLink="false"><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/FeatureStatusMonitor/<?= $feature->name ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>CRITICAL: Features expiring in 1 week: <?=$critical?></title>
 			<description>Number of features that will expire within 1 week</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
		<item>
			<guid isPermaLink="false"><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/FeatureStatusMonitor/<?= $feature->name ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>FATAL: Features that are already expired: <?=$fatal?></title>
 			<description>Number of features that are already expired</description>
			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
		</item>
	</channel>        
</rss>


<?/*
foreach ($list as $product) { 
 	$featureList = $product->getFeatures();
	$featureTTL = 60;
 
 	foreach ($featureList as $feature) {
 		if($feature->getExpiry() != 'N/A'){
 			//set the time to live of each chanel
			if ($feature->getExpiry() <= 168) {	?>
				
				<ttl><?= $feature->getExpiry() < 1 ? 60 : $feature->getExpiry()*60 ?></ttl>
				<item>
				<guid isPermaLink="false"><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/FeatureStatusMonitor/<?= $feature->name ?></guid>
				<pubDate><?= date('r') ?></pubDate>
				<title>WARNING: <?= $feature->name ?></title>
 				<description><?= $feature->name ?> will expire in  <?= $feature->getExpiryFormat() ?></description>
				<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
				</item>
			<?php
			}
 		}else{
 	?>
 			<item>
			<guid isPermaLink="false"><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/FeatureStatusMonitor/<?= $feature->name ?></guid>
			<pubDate><?= date('r') ?></pubDate>
			<title>CRITICAL: <?= $feature->name ?></title>
 			<description><![CDATA[<?= $feature->name ?> is already expired]]></description>
 			<link><?= $prefix ?>://<?= $_SERVER['HTTP_HOST'] ?>/module/feature_status</link>
			</item>
 			<?php 
 		}
 	}
 }*/
?>